/*
 * Copyright 2014 Ankush Sachdeva
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package github.ankushsachdeva.emojicon.emoji;

/**
 * @author Hieu Rocker (rockerhieu@gmail.com)
 */
public class Objects {
    public static final Emojicon[] DATA = new Emojicon[]{
            Emojicon.fromCodePoint(0x1f38d),
            Emojicon.fromCodePoint(0x1f49d),
            Emojicon.fromCodePoint(0x1f38e),
            Emojicon.fromCodePoint(0x1f392),
            Emojicon.fromCodePoint(0x1f393),
            Emojicon.fromCodePoint(0x1f38f),
            Emojicon.fromCodePoint(0x1f386),
            Emojicon.fromCodePoint(0x1f387),
            Emojicon.fromCodePoint(0x1f390),
            Emojicon.fromCodePoint(0x1f391),
            Emojicon.fromCodePoint(0x1f383),
            Emojicon.fromCodePoint(0x1f47b),
            Emojicon.fromCodePoint(0x1f385),
            Emojicon.fromCodePoint(0x1f384),
            Emojicon.fromCodePoint(0x1f381),
            Emojicon.fromCodePoint(0x1f38b),
            Emojicon.fromCodePoint(0x1f389),
            Emojicon.fromCodePoint(0x1f38a),
            Emojicon.fromCodePoint(0x1f388),
            Emojicon.fromCodePoint(0x1f38c),
            Emojicon.fromCodePoint(0x1f52e),
            Emojicon.fromCodePoint(0x1f3a5),
            Emojicon.fromCodePoint(0x1f4f7),
            Emojicon.fromCodePoint(0x1f4f9),
            Emojicon.fromCodePoint(0x1f4fc),
            Emojicon.fromCodePoint(0x1f4bf),
            Emojicon.fromCodePoint(0x1f4c0),
            Emojicon.fromCodePoint(0x1f4bd),
            Emojicon.fromCodePoint(0x1f4be),
            Emojicon.fromCodePoint(0x1f4bb),
            Emojicon.fromCodePoint(0x1f4f1),
            Emojicon.fromChar((char) 0x260e),
            Emojicon.fromCodePoint(0x1f4de),
            Emojicon.fromCodePoint(0x1f4df),
            Emojicon.fromCodePoint(0x1f4e0),
            Emojicon.fromCodePoint(0x1f4e1),
            Emojicon.fromCodePoint(0x1f4fa),
            Emojicon.fromCodePoint(0x1f4fb),
            Emojicon.fromCodePoint(0x1f508),
            Emojicon.fromCodePoint(0x1f509),
            Emojicon.fromCodePoint(0x1f50a),
            Emojicon.fromCodePoint(0x1f507),
            Emojicon.fromCodePoint(0x1f514),
            Emojicon.fromCodePoint(0x1f515),
            Emojicon.fromCodePoint(0x1f4e2),
            Emojicon.fromCodePoint(0x1f4e3),
            Emojicon.fromChar((char) 0x23f3),
            Emojicon.fromChar((char) 0x231b),
            Emojicon.fromChar((char) 0x23f0),
            Emojicon.fromChar((char) 0x231a),
            Emojicon.fromCodePoint(0x1f513),
            Emojicon.fromCodePoint(0x1f512),
            Emojicon.fromCodePoint(0x1f50f),
            Emojicon.fromCodePoint(0x1f510),
            Emojicon.fromCodePoint(0x1f511),
            Emojicon.fromCodePoint(0x1f50e),
            Emojicon.fromCodePoint(0x1f4a1),
            Emojicon.fromCodePoint(0x1f526),
            Emojicon.fromCodePoint(0x1f506),
            Emojicon.fromCodePoint(0x1f505),
            Emojicon.fromCodePoint(0x1f50c),
            Emojicon.fromCodePoint(0x1f50b),
            Emojicon.fromCodePoint(0x1f50d),
            Emojicon.fromCodePoint(0x1f6c1),
            Emojicon.fromCodePoint(0x1f6c0),
            Emojicon.fromCodePoint(0x1f6bf),
            Emojicon.fromCodePoint(0x1f6bd),
            Emojicon.fromCodePoint(0x1f527),
            Emojicon.fromCodePoint(0x1f529),
            Emojicon.fromCodePoint(0x1f528),
            Emojicon.fromCodePoint(0x1f6aa),
            Emojicon.fromCodePoint(0x1f6ac),
            Emojicon.fromCodePoint(0x1f4a3),
            Emojicon.fromCodePoint(0x1f52b),
            Emojicon.fromCodePoint(0x1f52a),
            Emojicon.fromCodePoint(0x1f48a),
            Emojicon.fromCodePoint(0x1f489),
            Emojicon.fromCodePoint(0x1f4b0),
            Emojicon.fromCodePoint(0x1f4b4),
            Emojicon.fromCodePoint(0x1f4b5),
            Emojicon.fromCodePoint(0x1f4b7),
            Emojicon.fromCodePoint(0x1f4b6),
            Emojicon.fromCodePoint(0x1f4b3),
            Emojicon.fromCodePoint(0x1f4b8),
            Emojicon.fromCodePoint(0x1f4f2),
            Emojicon.fromCodePoint(0x1f4e7),
            Emojicon.fromCodePoint(0x1f4e5),
            Emojicon.fromCodePoint(0x1f4e4),
            Emojicon.fromChar((char) 0x2709),
            Emojicon.fromCodePoint(0x1f4e9),
            Emojicon.fromCodePoint(0x1f4e8),
            Emojicon.fromCodePoint(0x1f4ef),
            Emojicon.fromCodePoint(0x1f4eb),
            Emojicon.fromCodePoint(0x1f4ea),
            Emojicon.fromCodePoint(0x1f4ec),
            Emojicon.fromCodePoint(0x1f4ed),
            Emojicon.fromCodePoint(0x1f4ee),
            Emojicon.fromCodePoint(0x1f4e6),
            Emojicon.fromCodePoint(0x1f4dd),
            Emojicon.fromCodePoint(0x1f4c4),
            Emojicon.fromCodePoint(0x1f4c3),
            Emojicon.fromCodePoint(0x1f4d1),
            Emojicon.fromCodePoint(0x1f4ca),
            Emojicon.fromCodePoint(0x1f4c8),
            Emojicon.fromCodePoint(0x1f4c9),
            Emojicon.fromCodePoint(0x1f4dc),
            Emojicon.fromCodePoint(0x1f4cb),
            Emojicon.fromCodePoint(0x1f4c5),
            Emojicon.fromCodePoint(0x1f4c6),
            Emojicon.fromCodePoint(0x1f4c7),
            Emojicon.fromCodePoint(0x1f4c1),
            Emojicon.fromCodePoint(0x1f4c2),
            Emojicon.fromChar((char) 0x2702),
            Emojicon.fromCodePoint(0x1f4cc),
            Emojicon.fromCodePoint(0x1f4ce),
            Emojicon.fromChar((char) 0x2712),
            Emojicon.fromChar((char) 0x270f),
            Emojicon.fromCodePoint(0x1f4cf),
            Emojicon.fromCodePoint(0x1f4d0),
            Emojicon.fromCodePoint(0x1f4d5),
            Emojicon.fromCodePoint(0x1f4d7),
            Emojicon.fromCodePoint(0x1f4d8),
            Emojicon.fromCodePoint(0x1f4d9),
            Emojicon.fromCodePoint(0x1f4d3),
            Emojicon.fromCodePoint(0x1f4d4),
            Emojicon.fromCodePoint(0x1f4d2),
            Emojicon.fromCodePoint(0x1f4da),
            Emojicon.fromCodePoint(0x1f4d6),
            Emojicon.fromCodePoint(0x1f516),
            Emojicon.fromCodePoint(0x1f4db),
            Emojicon.fromCodePoint(0x1f52c),
            Emojicon.fromCodePoint(0x1f52d),
            Emojicon.fromCodePoint(0x1f4f0),
            Emojicon.fromCodePoint(0x1f3a8),
            Emojicon.fromCodePoint(0x1f3ac),
            Emojicon.fromCodePoint(0x1f3a4),
            Emojicon.fromCodePoint(0x1f3a7),
            Emojicon.fromCodePoint(0x1f3bc),
            Emojicon.fromCodePoint(0x1f3b5),
            Emojicon.fromCodePoint(0x1f3b6),
            Emojicon.fromCodePoint(0x1f3b9),
            Emojicon.fromCodePoint(0x1f3bb),
            Emojicon.fromCodePoint(0x1f3ba),
            Emojicon.fromCodePoint(0x1f3b7),
            Emojicon.fromCodePoint(0x1f3b8),
            Emojicon.fromCodePoint(0x1f47e),
            Emojicon.fromCodePoint(0x1f3ae),
            Emojicon.fromCodePoint(0x1f0cf),
            Emojicon.fromCodePoint(0x1f3b4),
            Emojicon.fromCodePoint(0x1f004),
            Emojicon.fromCodePoint(0x1f3b2),
            Emojicon.fromCodePoint(0x1f3af),
            Emojicon.fromCodePoint(0x1f3c8),
            Emojicon.fromCodePoint(0x1f3c0),
            Emojicon.fromChar((char) 0x26bd),
            Emojicon.fromChar((char) 0x26be),
            Emojicon.fromCodePoint(0x1f3be),
            Emojicon.fromCodePoint(0x1f3b1),
            Emojicon.fromCodePoint(0x1f3c9),
            Emojicon.fromCodePoint(0x1f3b3),
            Emojicon.fromChar((char) 0x26f3),
            Emojicon.fromCodePoint(0x1f6b5),
            Emojicon.fromCodePoint(0x1f6b4),
            Emojicon.fromCodePoint(0x1f3c1),
            Emojicon.fromCodePoint(0x1f3c7),
            Emojicon.fromCodePoint(0x1f3c6),
            Emojicon.fromCodePoint(0x1f3bf),
            Emojicon.fromCodePoint(0x1f3c2),
            Emojicon.fromCodePoint(0x1f3ca),
            Emojicon.fromCodePoint(0x1f3c4),
            Emojicon.fromCodePoint(0x1f3a3),
            Emojicon.fromChar((char) 0x2615),
            Emojicon.fromCodePoint(0x1f375),
            Emojicon.fromCodePoint(0x1f376),
            Emojicon.fromCodePoint(0x1f37c),
            Emojicon.fromCodePoint(0x1f37a),
            Emojicon.fromCodePoint(0x1f37b),
            Emojicon.fromCodePoint(0x1f378),
            Emojicon.fromCodePoint(0x1f379),
            Emojicon.fromCodePoint(0x1f377),
            Emojicon.fromCodePoint(0x1f374),
            Emojicon.fromCodePoint(0x1f355),
            Emojicon.fromCodePoint(0x1f354),
            Emojicon.fromCodePoint(0x1f35f),
            Emojicon.fromCodePoint(0x1f357),
            Emojicon.fromCodePoint(0x1f356),
            Emojicon.fromCodePoint(0x1f35d),
            Emojicon.fromCodePoint(0x1f35b),
            Emojicon.fromCodePoint(0x1f364),
            Emojicon.fromCodePoint(0x1f371),
            Emojicon.fromCodePoint(0x1f363),
            Emojicon.fromCodePoint(0x1f365),
            Emojicon.fromCodePoint(0x1f359),
            Emojicon.fromCodePoint(0x1f358),
            Emojicon.fromCodePoint(0x1f35a),
            Emojicon.fromCodePoint(0x1f35c),
            Emojicon.fromCodePoint(0x1f372),
            Emojicon.fromCodePoint(0x1f362),
            Emojicon.fromCodePoint(0x1f361),
            Emojicon.fromCodePoint(0x1f373),
            Emojicon.fromCodePoint(0x1f35e),
            Emojicon.fromCodePoint(0x1f369),
            Emojicon.fromCodePoint(0x1f36e),
            Emojicon.fromCodePoint(0x1f366),
            Emojicon.fromCodePoint(0x1f368),
            Emojicon.fromCodePoint(0x1f367),
            Emojicon.fromCodePoint(0x1f382),
            Emojicon.fromCodePoint(0x1f370),
            Emojicon.fromCodePoint(0x1f36a),
            Emojicon.fromCodePoint(0x1f36b),
            Emojicon.fromCodePoint(0x1f36c),
            Emojicon.fromCodePoint(0x1f36d),
            Emojicon.fromCodePoint(0x1f36f),
            Emojicon.fromCodePoint(0x1f34e),
            Emojicon.fromCodePoint(0x1f34f),
            Emojicon.fromCodePoint(0x1f34a),
            Emojicon.fromCodePoint(0x1f34b),
            Emojicon.fromCodePoint(0x1f352),
            Emojicon.fromCodePoint(0x1f347),
            Emojicon.fromCodePoint(0x1f349),
            Emojicon.fromCodePoint(0x1f353),
            Emojicon.fromCodePoint(0x1f351),
            Emojicon.fromCodePoint(0x1f348),
            Emojicon.fromCodePoint(0x1f34c),
            Emojicon.fromCodePoint(0x1f350),
            Emojicon.fromCodePoint(0x1f34d),
            Emojicon.fromCodePoint(0x1f360),
            Emojicon.fromCodePoint(0x1f346),
            Emojicon.fromCodePoint(0x1f345),
            Emojicon.fromCodePoint(0x1f33d),
    };
}
