/*
 * Copyright 2014 Ankush Sachdeva
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package github.ankushsachdeva.emojicon.emoji;

/**
 * @author Hieu Rocker (rockerhieu@gmail.com)
 */
public class People {
    public static final Emojicon[] DATA = new Emojicon[]{
            Emojicon.fromCodePoint(0x1f604),
            Emojicon.fromCodePoint(0x1f603),
            Emojicon.fromCodePoint(0x1f600),
            Emojicon.fromCodePoint(0x1f60a),
            Emojicon.fromChar((char) 0x263a),
            Emojicon.fromCodePoint(0x1f609),
            Emojicon.fromCodePoint(0x1f60d),
            Emojicon.fromCodePoint(0x1f618),
            Emojicon.fromCodePoint(0x1f61a),
            Emojicon.fromCodePoint(0x1f617),
            Emojicon.fromCodePoint(0x1f619),
            Emojicon.fromCodePoint(0x1f61c),
            Emojicon.fromCodePoint(0x1f61d),
            Emojicon.fromCodePoint(0x1f61b),
            Emojicon.fromCodePoint(0x1f633),
            Emojicon.fromCodePoint(0x1f601),
            Emojicon.fromCodePoint(0x1f614),
            Emojicon.fromCodePoint(0x1f60c),
            Emojicon.fromCodePoint(0x1f612),
            Emojicon.fromCodePoint(0x1f61e),
            Emojicon.fromCodePoint(0x1f623),
            Emojicon.fromCodePoint(0x1f622),
            Emojicon.fromCodePoint(0x1f602),
            Emojicon.fromCodePoint(0x1f62d),
            Emojicon.fromCodePoint(0x1f62a),
            Emojicon.fromCodePoint(0x1f625),
            Emojicon.fromCodePoint(0x1f630),
            Emojicon.fromCodePoint(0x1f605),
            Emojicon.fromCodePoint(0x1f613),
            Emojicon.fromCodePoint(0x1f629),
            Emojicon.fromCodePoint(0x1f62b),
            Emojicon.fromCodePoint(0x1f628),
            Emojicon.fromCodePoint(0x1f631),
            Emojicon.fromCodePoint(0x1f620),
            Emojicon.fromCodePoint(0x1f621),
            Emojicon.fromCodePoint(0x1f624),
            Emojicon.fromCodePoint(0x1f616),
            Emojicon.fromCodePoint(0x1f606),
            Emojicon.fromCodePoint(0x1f60b),
            Emojicon.fromCodePoint(0x1f637),
            Emojicon.fromCodePoint(0x1f60e),
            Emojicon.fromCodePoint(0x1f634),
            Emojicon.fromCodePoint(0x1f635),
            Emojicon.fromCodePoint(0x1f632),
            Emojicon.fromCodePoint(0x1f61f),
            Emojicon.fromCodePoint(0x1f626),
            Emojicon.fromCodePoint(0x1f627),
            Emojicon.fromCodePoint(0x1f608),
            Emojicon.fromCodePoint(0x1f47f),
            Emojicon.fromCodePoint(0x1f62e),
            Emojicon.fromCodePoint(0x1f62c),
            Emojicon.fromCodePoint(0x1f610),
            Emojicon.fromCodePoint(0x1f615),
            Emojicon.fromCodePoint(0x1f62f),
            Emojicon.fromCodePoint(0x1f636),
            Emojicon.fromCodePoint(0x1f607),
            Emojicon.fromCodePoint(0x1f60f),
            Emojicon.fromCodePoint(0x1f611),
            Emojicon.fromCodePoint(0x1f472),
            Emojicon.fromCodePoint(0x1f473),
            Emojicon.fromCodePoint(0x1f46e),
            Emojicon.fromCodePoint(0x1f477),
            Emojicon.fromCodePoint(0x1f482),
            Emojicon.fromCodePoint(0x1f476),
            Emojicon.fromCodePoint(0x1f466),
            Emojicon.fromCodePoint(0x1f467),
            Emojicon.fromCodePoint(0x1f468),
            Emojicon.fromCodePoint(0x1f469),
            Emojicon.fromCodePoint(0x1f474),
            Emojicon.fromCodePoint(0x1f475),
            Emojicon.fromCodePoint(0x1f471),
            Emojicon.fromCodePoint(0x1f47c),
            Emojicon.fromCodePoint(0x1f478),
            Emojicon.fromCodePoint(0x1f63a),
            Emojicon.fromCodePoint(0x1f638),
            Emojicon.fromCodePoint(0x1f63b),
            Emojicon.fromCodePoint(0x1f63d),
            Emojicon.fromCodePoint(0x1f63c),
            Emojicon.fromCodePoint(0x1f640),
            Emojicon.fromCodePoint(0x1f63f),
            Emojicon.fromCodePoint(0x1f639),
            Emojicon.fromCodePoint(0x1f63e),
            Emojicon.fromCodePoint(0x1f479),
            Emojicon.fromCodePoint(0x1f47a),
            Emojicon.fromCodePoint(0x1f648),
            Emojicon.fromCodePoint(0x1f649),
            Emojicon.fromCodePoint(0x1f64a),
            Emojicon.fromCodePoint(0x1f480),
            Emojicon.fromCodePoint(0x1f47d),
            Emojicon.fromCodePoint(0x1f4a9),
            Emojicon.fromCodePoint(0x1f525),
            Emojicon.fromChar((char) 0x2728),
            Emojicon.fromCodePoint(0x1f31f),
            Emojicon.fromCodePoint(0x1f4ab),
            Emojicon.fromCodePoint(0x1f4a5),
            Emojicon.fromCodePoint(0x1f4a2),
            Emojicon.fromCodePoint(0x1f4a6),
            Emojicon.fromCodePoint(0x1f4a7),
            Emojicon.fromCodePoint(0x1f4a4),
            Emojicon.fromCodePoint(0x1f4a8),
            Emojicon.fromCodePoint(0x1f442),
            Emojicon.fromCodePoint(0x1f440),
            Emojicon.fromCodePoint(0x1f443),
            Emojicon.fromCodePoint(0x1f445),
            Emojicon.fromCodePoint(0x1f444),
            Emojicon.fromCodePoint(0x1f44d),
            Emojicon.fromCodePoint(0x1f44e),
            Emojicon.fromCodePoint(0x1f44c),
            Emojicon.fromCodePoint(0x1f44a),
            Emojicon.fromChar((char) 0x270a),
            Emojicon.fromChar((char) 0x270c),
            Emojicon.fromCodePoint(0x1f44b),
            Emojicon.fromChar((char) 0x270b),
            Emojicon.fromCodePoint(0x1f450),
            Emojicon.fromCodePoint(0x1f446),
            Emojicon.fromCodePoint(0x1f447),
            Emojicon.fromCodePoint(0x1f449),
            Emojicon.fromCodePoint(0x1f448),
            Emojicon.fromCodePoint(0x1f64c),
            Emojicon.fromCodePoint(0x1f64f),
            Emojicon.fromChar((char) 0x261d),
            Emojicon.fromCodePoint(0x1f44f),
            Emojicon.fromCodePoint(0x1f4aa),
            Emojicon.fromCodePoint(0x1f6b6),
            Emojicon.fromCodePoint(0x1f3c3),
            Emojicon.fromCodePoint(0x1f483),
            Emojicon.fromCodePoint(0x1f46b),
            Emojicon.fromCodePoint(0x1f46a),
            Emojicon.fromCodePoint(0x1f46c),
            Emojicon.fromCodePoint(0x1f46d),
            Emojicon.fromCodePoint(0x1f48f),
            Emojicon.fromCodePoint(0x1f491),
            Emojicon.fromCodePoint(0x1f46f),
            Emojicon.fromCodePoint(0x1f646),
            Emojicon.fromCodePoint(0x1f645),
            Emojicon.fromCodePoint(0x1f481),
            Emojicon.fromCodePoint(0x1f64b),
            Emojicon.fromCodePoint(0x1f486),
            Emojicon.fromCodePoint(0x1f487),
            Emojicon.fromCodePoint(0x1f485),
            Emojicon.fromCodePoint(0x1f470),
            Emojicon.fromCodePoint(0x1f64e),
            Emojicon.fromCodePoint(0x1f64d),
            Emojicon.fromCodePoint(0x1f647),
            Emojicon.fromCodePoint(0x1f3a9),
            Emojicon.fromCodePoint(0x1f451),
            Emojicon.fromCodePoint(0x1f452),
            Emojicon.fromCodePoint(0x1f45f),
            Emojicon.fromCodePoint(0x1f45e),
            Emojicon.fromCodePoint(0x1f461),
            Emojicon.fromCodePoint(0x1f460),
            Emojicon.fromCodePoint(0x1f462),
            Emojicon.fromCodePoint(0x1f455),
            Emojicon.fromCodePoint(0x1f454),
            Emojicon.fromCodePoint(0x1f45a),
            Emojicon.fromCodePoint(0x1f457),
            Emojicon.fromCodePoint(0x1f3bd),
            Emojicon.fromCodePoint(0x1f456),
            Emojicon.fromCodePoint(0x1f458),
            Emojicon.fromCodePoint(0x1f459),
            Emojicon.fromCodePoint(0x1f4bc),
            Emojicon.fromCodePoint(0x1f45c),
            Emojicon.fromCodePoint(0x1f45d),
            Emojicon.fromCodePoint(0x1f45b),
            Emojicon.fromCodePoint(0x1f453),
            Emojicon.fromCodePoint(0x1f380),
            Emojicon.fromCodePoint(0x1f302),
            Emojicon.fromCodePoint(0x1f484),
            Emojicon.fromCodePoint(0x1f49b),
            Emojicon.fromCodePoint(0x1f499),
            Emojicon.fromCodePoint(0x1f49c),
            Emojicon.fromCodePoint(0x1f49a),
            Emojicon.fromChar((char) 0x2764),
            Emojicon.fromCodePoint(0x1f494),
            Emojicon.fromCodePoint(0x1f497),
            Emojicon.fromCodePoint(0x1f493),
            Emojicon.fromCodePoint(0x1f495),
            Emojicon.fromCodePoint(0x1f496),
            Emojicon.fromCodePoint(0x1f49e),
            Emojicon.fromCodePoint(0x1f498),
            Emojicon.fromCodePoint(0x1f48c),
            Emojicon.fromCodePoint(0x1f48b),
            Emojicon.fromCodePoint(0x1f48d),
            Emojicon.fromCodePoint(0x1f48e),
            Emojicon.fromCodePoint(0x1f464),
            Emojicon.fromCodePoint(0x1f465),
            Emojicon.fromCodePoint(0x1f4ac),
            Emojicon.fromCodePoint(0x1f463),
            Emojicon.fromCodePoint(0x1f4ad),
    };
}
