/*
 * Copyright 2014 Ankush Sachdeva
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package github.ankushsachdeva.emojicon.emoji;

/**
 * @author Hieu Rocker (rockerhieu@gmail.com)
 */
public class Places {
    public static final Emojicon[] DATA = new Emojicon[]{
            Emojicon.fromCodePoint(0x1f3e0),
            Emojicon.fromCodePoint(0x1f3e1),
            Emojicon.fromCodePoint(0x1f3eb),
            Emojicon.fromCodePoint(0x1f3e2),
            Emojicon.fromCodePoint(0x1f3e3),
            Emojicon.fromCodePoint(0x1f3e5),
            Emojicon.fromCodePoint(0x1f3e6),
            Emojicon.fromCodePoint(0x1f3ea),
            Emojicon.fromCodePoint(0x1f3e9),
            Emojicon.fromCodePoint(0x1f3e8),
            Emojicon.fromCodePoint(0x1f492),
            Emojicon.fromChar((char) 0x26ea),
            Emojicon.fromCodePoint(0x1f3ec),
            Emojicon.fromCodePoint(0x1f3e4),
            Emojicon.fromCodePoint(0x1f307),
            Emojicon.fromCodePoint(0x1f306),
            Emojicon.fromCodePoint(0x1f3ef),
            Emojicon.fromCodePoint(0x1f3f0),
            Emojicon.fromChar((char) 0x26fa),
            Emojicon.fromCodePoint(0x1f3ed),
            Emojicon.fromCodePoint(0x1f5fc),
            Emojicon.fromCodePoint(0x1f5fe),
            Emojicon.fromCodePoint(0x1f5fb),
            Emojicon.fromCodePoint(0x1f304),
            Emojicon.fromCodePoint(0x1f305),
            Emojicon.fromCodePoint(0x1f303),
            Emojicon.fromCodePoint(0x1f5fd),
            Emojicon.fromCodePoint(0x1f309),
            Emojicon.fromCodePoint(0x1f3a0),
            Emojicon.fromCodePoint(0x1f3a1),
            Emojicon.fromChar((char) 0x26f2),
            Emojicon.fromCodePoint(0x1f3a2),
            Emojicon.fromCodePoint(0x1f6a2),
            Emojicon.fromChar((char) 0x26f5),
            Emojicon.fromCodePoint(0x1f6a4),
            Emojicon.fromCodePoint(0x1f6a3),
            Emojicon.fromChar((char) 0x2693),
            Emojicon.fromCodePoint(0x1f680),
            Emojicon.fromChar((char) 0x2708),
            Emojicon.fromCodePoint(0x1f4ba),
            Emojicon.fromCodePoint(0x1f681),
            Emojicon.fromCodePoint(0x1f682),
            Emojicon.fromCodePoint(0x1f68a),
            Emojicon.fromCodePoint(0x1f689),
            Emojicon.fromCodePoint(0x1f69e),
            Emojicon.fromCodePoint(0x1f686),
            Emojicon.fromCodePoint(0x1f684),
            Emojicon.fromCodePoint(0x1f685),
            Emojicon.fromCodePoint(0x1f688),
            Emojicon.fromCodePoint(0x1f687),
            Emojicon.fromCodePoint(0x1f69d),
            Emojicon.fromCodePoint(0x1f68b),
            Emojicon.fromCodePoint(0x1f683),
            Emojicon.fromCodePoint(0x1f68e),
            Emojicon.fromCodePoint(0x1f68c),
            Emojicon.fromCodePoint(0x1f68d),
            Emojicon.fromCodePoint(0x1f699),
            Emojicon.fromCodePoint(0x1f698),
            Emojicon.fromCodePoint(0x1f697),
            Emojicon.fromCodePoint(0x1f695),
            Emojicon.fromCodePoint(0x1f696),
            Emojicon.fromCodePoint(0x1f69b),
            Emojicon.fromCodePoint(0x1f69a),
            Emojicon.fromCodePoint(0x1f6a8),
            Emojicon.fromCodePoint(0x1f693),
            Emojicon.fromCodePoint(0x1f694),
            Emojicon.fromCodePoint(0x1f692),
            Emojicon.fromCodePoint(0x1f691),
            Emojicon.fromCodePoint(0x1f690),
            Emojicon.fromCodePoint(0x1f6b2),
            Emojicon.fromCodePoint(0x1f6a1),
            Emojicon.fromCodePoint(0x1f69f),
            Emojicon.fromCodePoint(0x1f6a0),
            Emojicon.fromCodePoint(0x1f69c),
            Emojicon.fromCodePoint(0x1f488),
            Emojicon.fromCodePoint(0x1f68f),
            Emojicon.fromCodePoint(0x1f3ab),
            Emojicon.fromCodePoint(0x1f6a6),
            Emojicon.fromCodePoint(0x1f6a5),
            Emojicon.fromChar((char) 0x26a0),
            Emojicon.fromCodePoint(0x1f6a7),
            Emojicon.fromCodePoint(0x1f530),
            Emojicon.fromChar((char) 0x26fd),
            Emojicon.fromCodePoint(0x1f3ee),
            Emojicon.fromCodePoint(0x1f3b0),
            Emojicon.fromChar((char) 0x2668),
            Emojicon.fromCodePoint(0x1f5ff),
            Emojicon.fromCodePoint(0x1f3aa),
            Emojicon.fromCodePoint(0x1f3ad),
            Emojicon.fromCodePoint(0x1f4cd),
            Emojicon.fromCodePoint(0x1f6a9),
            Emojicon.fromChars("\ud83c\uddef\ud83c\uddf5"),
            Emojicon.fromChars("\ud83c\uddf0\ud83c\uddf7"),
            Emojicon.fromChars("\ud83c\udde9\ud83c\uddea"),
            Emojicon.fromChars("\ud83c\udde8\ud83c\uddf3"),
            Emojicon.fromChars("\ud83c\uddfa\ud83c\uddf8"),
            Emojicon.fromChars("\ud83c\uddeb\ud83c\uddf7"),
            Emojicon.fromChars("\ud83c\uddea\ud83c\uddf8"),
            Emojicon.fromChars("\ud83c\uddee\ud83c\uddf9"),
            Emojicon.fromChars("\ud83c\uddf7\ud83c\uddfa"),
            Emojicon.fromChars("\ud83c\uddec\ud83c\udde7"),
    };
}
