/*
 * Copyright 2014 Ankush Sachdeva
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package github.ankushsachdeva.emojicon.emoji;

/**
 * @author Hieu Rocker (rockerhieu@gmail.com)
 */
public class Symbols {
    public static final Emojicon[] DATA = new Emojicon[]{
            Emojicon.fromChars("\u0031\u20e3"),
            Emojicon.fromChars("\u0032\u20e3"),
            Emojicon.fromChars("\u0033\u20e3"),
            Emojicon.fromChars("\u0034\u20e3"),
            Emojicon.fromChars("\u0035\u20e3"),
            Emojicon.fromChars("\u0036\u20e3"),
            Emojicon.fromChars("\u0037\u20e3"),
            Emojicon.fromChars("\u0038\u20e3"),
            Emojicon.fromChars("\u0039\u20e3"),
            Emojicon.fromChars("\u0030\u20e3"),
            Emojicon.fromCodePoint(0x1f51f),
            Emojicon.fromCodePoint(0x1f522),
            Emojicon.fromChars("\u0023\u20e3"),
            Emojicon.fromCodePoint(0x1f523),
            Emojicon.fromChar((char) 0x2b06),
            Emojicon.fromChar((char) 0x2b07),
            Emojicon.fromChar((char) 0x2b05),
            Emojicon.fromChar((char) 0x27a1),
            Emojicon.fromCodePoint(0x1f520),
            Emojicon.fromCodePoint(0x1f521),
            Emojicon.fromCodePoint(0x1f524),
            Emojicon.fromChar((char) 0x2197),
            Emojicon.fromChar((char) 0x2196),
            Emojicon.fromChar((char) 0x2198),
            Emojicon.fromChar((char) 0x2199),
            Emojicon.fromChar((char) 0x2194),
            Emojicon.fromChar((char) 0x2195),
            Emojicon.fromCodePoint(0x1f504),
            Emojicon.fromChar((char) 0x25c0),
            Emojicon.fromChar((char) 0x25b6),
            Emojicon.fromCodePoint(0x1f53c),
            Emojicon.fromCodePoint(0x1f53d),
            Emojicon.fromChar((char) 0x21a9),
            Emojicon.fromChar((char) 0x21aa),
            Emojicon.fromChar((char) 0x2139),
            Emojicon.fromChar((char) 0x23ea),
            Emojicon.fromChar((char) 0x23e9),
            Emojicon.fromChar((char) 0x23eb),
            Emojicon.fromChar((char) 0x23ec),
            Emojicon.fromChar((char) 0x2935),
            Emojicon.fromChar((char) 0x2934),
            Emojicon.fromCodePoint(0x1f197),
            Emojicon.fromCodePoint(0x1f500),
            Emojicon.fromCodePoint(0x1f501),
            Emojicon.fromCodePoint(0x1f502),
            Emojicon.fromCodePoint(0x1f195),
            Emojicon.fromCodePoint(0x1f199),
            Emojicon.fromCodePoint(0x1f192),
            Emojicon.fromCodePoint(0x1f193),
            Emojicon.fromCodePoint(0x1f196),
            Emojicon.fromCodePoint(0x1f4f6),
            Emojicon.fromCodePoint(0x1f3a6),
            Emojicon.fromCodePoint(0x1f201),
            Emojicon.fromCodePoint(0x1f22f),
            Emojicon.fromCodePoint(0x1f233),
            Emojicon.fromCodePoint(0x1f235),
            Emojicon.fromCodePoint(0x1f234),
            Emojicon.fromCodePoint(0x1f232),
            Emojicon.fromCodePoint(0x1f250),
            Emojicon.fromCodePoint(0x1f239),
            Emojicon.fromCodePoint(0x1f23a),
            Emojicon.fromCodePoint(0x1f236),
            Emojicon.fromCodePoint(0x1f21a),
            Emojicon.fromCodePoint(0x1f6bb),
            Emojicon.fromCodePoint(0x1f6b9),
            Emojicon.fromCodePoint(0x1f6ba),
            Emojicon.fromCodePoint(0x1f6bc),
            Emojicon.fromCodePoint(0x1f6be),
            Emojicon.fromCodePoint(0x1f6b0),
            Emojicon.fromCodePoint(0x1f6ae),
            Emojicon.fromCodePoint(0x1f17f),
            Emojicon.fromChar((char) 0x267f),
            Emojicon.fromCodePoint(0x1f6ad),
            Emojicon.fromCodePoint(0x1f237),
            Emojicon.fromCodePoint(0x1f238),
            Emojicon.fromCodePoint(0x1f202),
            Emojicon.fromChar((char) 0x24c2),
            Emojicon.fromCodePoint(0x1f6c2),
            Emojicon.fromCodePoint(0x1f6c4),
            Emojicon.fromCodePoint(0x1f6c5),
            Emojicon.fromCodePoint(0x1f6c3),
            Emojicon.fromCodePoint(0x1f251),
            Emojicon.fromChar((char) 0x3299),
            Emojicon.fromChar((char) 0x3297),
            Emojicon.fromCodePoint(0x1f191),
            Emojicon.fromCodePoint(0x1f198),
            Emojicon.fromCodePoint(0x1f194),
            Emojicon.fromCodePoint(0x1f6ab),
            Emojicon.fromCodePoint(0x1f51e),
            Emojicon.fromCodePoint(0x1f4f5),
            Emojicon.fromCodePoint(0x1f6af),
            Emojicon.fromCodePoint(0x1f6b1),
            Emojicon.fromCodePoint(0x1f6b3),
            Emojicon.fromCodePoint(0x1f6b7),
            Emojicon.fromCodePoint(0x1f6b8),
            Emojicon.fromChar((char) 0x26d4),
            Emojicon.fromChar((char) 0x2733),
            Emojicon.fromChar((char) 0x2747),
            Emojicon.fromChar((char) 0x274e),
            Emojicon.fromChar((char) 0x2705),
            Emojicon.fromChar((char) 0x2734),
            Emojicon.fromCodePoint(0x1f49f),
            Emojicon.fromCodePoint(0x1f19a),
            Emojicon.fromCodePoint(0x1f4f3),
            Emojicon.fromCodePoint(0x1f4f4),
            Emojicon.fromCodePoint(0x1f170),
            Emojicon.fromCodePoint(0x1f171),
            Emojicon.fromCodePoint(0x1f18e),
            Emojicon.fromCodePoint(0x1f17e),
            Emojicon.fromCodePoint(0x1f4a0),
            Emojicon.fromChar((char) 0x27bf),
            Emojicon.fromChar((char) 0x267b),
            Emojicon.fromChar((char) 0x2648),
            Emojicon.fromChar((char) 0x2649),
            Emojicon.fromChar((char) 0x264a),
            Emojicon.fromChar((char) 0x264b),
            Emojicon.fromChar((char) 0x264c),
            Emojicon.fromChar((char) 0x264d),
            Emojicon.fromChar((char) 0x264e),
            Emojicon.fromChar((char) 0x264f),
            Emojicon.fromChar((char) 0x2650),
            Emojicon.fromChar((char) 0x2651),
            Emojicon.fromChar((char) 0x2652),
            Emojicon.fromChar((char) 0x2653),
            Emojicon.fromChar((char) 0x26ce),
            Emojicon.fromCodePoint(0x1f52f),
            Emojicon.fromCodePoint(0x1f3e7),
            Emojicon.fromCodePoint(0x1f4b9),
            Emojicon.fromCodePoint(0x1f4b2),
            Emojicon.fromCodePoint(0x1f4b1),
//            Emoji.fromChar((char)0x00a9),
//            Emoji.fromChar((char)0x00ae),
            Emojicon.fromChar((char) 0xe24e),
            Emojicon.fromChar((char) 0xe24f),

            Emojicon.fromChar((char) 0x2122),
            Emojicon.fromChar((char) 0x274c),
            Emojicon.fromChar((char) 0x203c),
            Emojicon.fromChar((char) 0x2049),
            Emojicon.fromChar((char) 0x2757),
            Emojicon.fromChar((char) 0x2753),
            Emojicon.fromChar((char) 0x2755),
            Emojicon.fromChar((char) 0x2754),
            Emojicon.fromChar((char) 0x2b55),
            Emojicon.fromCodePoint(0x1f51d),
            Emojicon.fromCodePoint(0x1f51a),
            Emojicon.fromCodePoint(0x1f519),
            Emojicon.fromCodePoint(0x1f51b),
            Emojicon.fromCodePoint(0x1f51c),
            Emojicon.fromCodePoint(0x1f503),
            Emojicon.fromCodePoint(0x1f55b),
            Emojicon.fromCodePoint(0x1f567),
            Emojicon.fromCodePoint(0x1f550),
            Emojicon.fromCodePoint(0x1f55c),
            Emojicon.fromCodePoint(0x1f551),
            Emojicon.fromCodePoint(0x1f55d),
            Emojicon.fromCodePoint(0x1f552),
            Emojicon.fromCodePoint(0x1f55e),
            Emojicon.fromCodePoint(0x1f553),
            Emojicon.fromCodePoint(0x1f55f),
            Emojicon.fromCodePoint(0x1f554),
            Emojicon.fromCodePoint(0x1f560),
            Emojicon.fromCodePoint(0x1f555),
            Emojicon.fromCodePoint(0x1f556),
            Emojicon.fromCodePoint(0x1f557),
            Emojicon.fromCodePoint(0x1f558),
            Emojicon.fromCodePoint(0x1f559),
            Emojicon.fromCodePoint(0x1f55a),
            Emojicon.fromCodePoint(0x1f561),
            Emojicon.fromCodePoint(0x1f562),
            Emojicon.fromCodePoint(0x1f563),
            Emojicon.fromCodePoint(0x1f564),
            Emojicon.fromCodePoint(0x1f565),
            Emojicon.fromCodePoint(0x1f566),
            Emojicon.fromChar((char) 0x2716),
            Emojicon.fromChar((char) 0x2795),
            Emojicon.fromChar((char) 0x2796),
            Emojicon.fromChar((char) 0x2797),
            Emojicon.fromChar((char) 0x2660),
            Emojicon.fromChar((char) 0x2665),
            Emojicon.fromChar((char) 0x2663),
            Emojicon.fromChar((char) 0x2666),
            Emojicon.fromCodePoint(0x1f4ae),
            Emojicon.fromCodePoint(0x1f4af),
            Emojicon.fromChar((char) 0x2714),
            Emojicon.fromChar((char) 0x2611),
            Emojicon.fromCodePoint(0x1f518),
            Emojicon.fromCodePoint(0x1f517),
            Emojicon.fromChar((char) 0x27b0),
            Emojicon.fromChar((char) 0x3030),
            Emojicon.fromChar((char) 0x303d),
            Emojicon.fromCodePoint(0x1f531),
            Emojicon.fromChar((char) 0x25fc),
            Emojicon.fromChar((char) 0x25fb),
            Emojicon.fromChar((char) 0x25fe),
            Emojicon.fromChar((char) 0x25fd),
            Emojicon.fromChar((char) 0x25aa),
            Emojicon.fromChar((char) 0x25ab),
            Emojicon.fromCodePoint(0x1f53a),
            Emojicon.fromCodePoint(0x1f532),
            Emojicon.fromCodePoint(0x1f533),
            Emojicon.fromChar((char) 0x26ab),
            Emojicon.fromChar((char) 0x26aa),
            Emojicon.fromCodePoint(0x1f534),
            Emojicon.fromCodePoint(0x1f535),
            Emojicon.fromCodePoint(0x1f53b),
            Emojicon.fromChar((char) 0x2b1c),
            Emojicon.fromChar((char) 0x2b1b),
            Emojicon.fromCodePoint(0x1f536),
            Emojicon.fromCodePoint(0x1f537),
            Emojicon.fromCodePoint(0x1f538),
            Emojicon.fromCodePoint(0x1f539),
    };
}
