<?php

    /*!
     * ifsoft.co.uk engine v1.0
     *
     * http://ifsoft.com.ua, http://ifsoft.co.uk
     * qascript@ifsoft.co.uk
     *
     * Copyright 2012-2015 Demyanchuk Dmitry (https://vk.com/dmitry.demyanchuk)
     */

    if (!admin::isSession()) {

        header("Location: /admin/login");
    }

    $accountInfo = array();

    if (isset($_GET['id'])) {

        $accountId = isset($_GET['id']) ? $_GET['id'] : 0;

        $account = new account($dbo, $accountId);
        $accountInfo = $account->get();

    } else {

        header("Location: /admin/main");
    }

    if ($accountInfo['error'] === true) {

        header("Location: /admin/main");
    }

    $stats = new stats($dbo);

    $page_id = "items";

    $posts = new post($dbo);
    $posts->setRequestFrom($accountInfo['id']);

    $inbox_all = $posts->count();
    $inbox_loaded = 0;

    if (!empty($_POST)) {

        $itemId = isset($_POST['itemId']) ? $_POST['itemId'] : '';
        $loaded = isset($_POST['loaded']) ? $_POST['loaded'] : '';

        $itemId = helper::clearInt($itemId);
        $loaded = helper::clearInt($loaded);

        $result = $posts->get($accountId, $itemId);

        $inbox_loaded = count($result['posts']);

        $result['inbox_loaded'] = $inbox_loaded + $loaded;
        $result['inbox_all'] = $inbox_all;

        if ($inbox_loaded != 0) {

            ob_start();

            foreach ($result['posts'] as $key => $value) {

                draw($value, $helper);
            }

            if ($result['inbox_loaded'] < $inbox_all) {

                ?>

                <div class="more_cont">
                    <a class="more_link" href="javascript:void(0)" onclick="Profile.moreItems('<?php echo $result['postId']; ?>'); return false;">View more</a>
                    <a class="loading_link" href="javascript:void(0)" style="display: none">&nbsp;</a>
                </div>

                <?php
            }

            $result['html'] = ob_get_clean();
        }

        echo json_encode($result);
        exit;
    }

    $css_files = array("admin.css");
    $page_title = "User items";

    include_once("../html/common/header.inc.php");

?>

<body class="bg_gray">

<div id="page_wrap">

    <?php

        include_once("../html/common/admin_panel_topbar.inc.php");
    ?>

    <div id="page_layout">

        <?php

            include_once("../html/common/admin_panel_banner.inc.php");
        ?>

        <div id="page_body">
            <div id="wrap3">
                <div id="wrap2">
                    <div id="wrap1">

                        <div id="content">

                            <div class="header">
                                <div class="title">
                                    <span>User items</span>
                                </div>
                            </div>

                            <div id="items_cont" class="items_cont">

                                <?php

                                    $result = $posts->get($accountId, 0);

                                    $inbox_loaded = count($result['posts']);

                                    if ($inbox_loaded != 0) {

                                        foreach ($result['posts'] as $key => $value) {

                                            draw($value, $helper);
                                        }

                                    } else {

                                        ?>

                                        <div class="info">
                                            List is empty.
                                        </div>

                                        <?php
                                }
                                ?>

                                <?php

                                if ($inbox_all > 20) {

                                    ?>

                                    <div class="more_cont">
                                        <a class="more_link" href="javascript:void(0)" onclick="Profile.moreItems('<?php echo $result['postId']; ?>'); return false;">View more</a>
                                        <a class="loading_link" href="javascript:void(0)" style="display: none">&nbsp;</a>
                                    </div>

                                <?php
                                }

                                ?>

                            </div>

                        </div>
                    </div>
                </div>
            </div>
        </div>

        <?php

            include_once("../html/common/admin_panel_footer.inc.php");
        ?>

        <script type="text/javascript">

            var inbox_all = <?php echo $inbox_all; ?>;
            var inbox_loaded = <?php echo $inbox_loaded; ?>;

            window.Post || ( window.Post = {} );

            Post.remove = function (offset, fromUserId, accessToken) {

                $.ajax({
                    type: 'GET',
                    url: '/admin/stream/?id=' + offset + '&fromUserId=' + fromUserId + '&access_token=' + accessToken,
                    data: 'itemId=' + offset + '&fromUserId=' + fromUserId + "&access_token=" + accessToken,
                    timeout: 30000,
                    success: function(response){

                        $('div.post_item[data-id=' + offset + ']').remove();
                    },
                    error: function(xhr, type){

                    }
                });
            };

            window.Profile || ( window.Profile = {} );

            Profile.moreItems = function (offset) {

                $('a.more_link').hide();
                $('a.loading_link').show();

                $.ajax({
                    type: 'POST',
                    url: '/admin/profile_items/?id=' + <?php echo $accountInfo['id'] ?>,
                    data: 'itemId=' + offset + "&loaded=" + inbox_loaded,
                    dataType: 'json',
                    timeout: 30000,
                    success: function(response){

                        $('div.more_cont').remove();

                        if (response.hasOwnProperty('html')){

                            $("div.items_cont").append(response.html);
                        }

                        inbox_loaded = response.inbox_loaded;
                        inbox_all = response.inbox_all;
                    },
                    error: function(xhr, type){

                        $('a.more_link').show();
                        $('a.loading_link').hide();
                    }
                });
            };

        </script>

    </div>

</body>
</html>

<?php

    function draw($post, $helper = null) {

            $post['post'] = helper::processPostText($post['post']);

            $fromUserPhoto = "/img/profile_default_photo.png";

            if (strlen($post['fromUserPhoto']) != 0) {

                $fromUserPhoto = $post['fromUserPhoto'];
            }

        ?>

        <div class="post post_item" data-id="<?php echo $post['id']; ?>">

            <a class="profile_cont" href="/admin/profile/?id=<?php echo $post['fromUserId']; ?>">
                <img src="<?php echo $fromUserPhoto; ?>">
            </a>

            <div class="post_content">

                <div class="action_remove" onclick="Post.remove('<?php echo $post['id']; ?>', '<?php echo $post['fromUserId']; ?>', '<?php echo admin::getAccessToken(); ?>'); return false;"></div>

                <div class="post_data" style="font-weight: normal">
                    <?php echo $post['post']; ?>
                </div>

                <?php

                    if (strlen($post['imgUrl']) != 0) {

                        ?>
                            <div class="post_img">
                                <img style="max-width: 600px;" src="<?php echo $post['imgUrl']; ?>">
                            </div>
                        <?php
                    }
                ?>

                <div class="post_footer">
                    <span class="time"><?php echo $post['timeAgo']; ?> | <?php echo $post['date']; ?></span>
                </div>

            </div>
        </div>

    <?php
    }