<?php

    /*!
     * ifsoft.co.uk engine v1.0
     *
     * http://ifsoft.com.ua, http://ifsoft.co.uk, https://racconsquare.com
     * racconsquare@gmail.com
     *
     * Copyright 2012-2019 Demyanchuk Dmitry (racconsquare@gmail.com)
     */

    if (!admin::isSession()) {

        header("Location: /admin/login");
        exit;
    }

    $stats = new stats($dbo);
    $settings = new settings($dbo);
    $admin = new admin($dbo);

    $allowPhotoModeration = 1;
    $allowCoverModeration = 1;

    $allowFacebookAuthorization = 1;
    $allowMultiAccountsFunction = 1;

    if (!empty($_POST)) {

        $authToken = isset($_POST['authenticity_token']) ? $_POST['authenticity_token'] : '';

        $allowPhotoModeration_checkbox = isset($_POST['allowPhotoModeration']) ? $_POST['allowPhotoModeration'] : '';
        $allowCoverModeration_checkbox = isset($_POST['allowCoverModeration']) ? $_POST['allowCoverModeration'] : '';

        $allowFacebookAuthorization_checkbox = isset($_POST['allowFacebookAuthorization']) ? $_POST['allowFacebookAuthorization'] : '';
        $allowMultiAccountsFunction_checkbox = isset($_POST['allowMultiAccountsFunction']) ? $_POST['allowMultiAccountsFunction'] : '';

        if ($authToken === helper::getAuthenticityToken() && !APP_DEMO) {

            if ($allowPhotoModeration_checkbox === "on") {

                $allowPhotoModeration = 1;

            } else {

                $allowPhotoModeration = 0;
            }

            if ($allowCoverModeration_checkbox === "on") {

                $allowCoverModeration = 1;

            } else {

                $allowCoverModeration = 0;
            }

            if ($allowFacebookAuthorization_checkbox === "on") {

                $allowFacebookAuthorization = 1;

            } else {

                $allowFacebookAuthorization = 0;
            }

            if ($allowMultiAccountsFunction_checkbox === "on") {

                $allowMultiAccountsFunction = 1;

            } else {

                $allowMultiAccountsFunction = 0;
            }

            $settings->setValue("photoModeration", $allowPhotoModeration);
            $settings->setValue("coverModeration", $allowCoverModeration);

            $settings->setValue("allowFacebookAuthorization", $allowFacebookAuthorization);
            $settings->setValue("allowMultiAccountsFunction", $allowMultiAccountsFunction);
        }
    }

    $config = $settings->get();

    $arr = array();

    $arr = $config['photoModeration'];
    $allowPhotoModeration = $arr['intValue'];

    $arr = $config['coverModeration'];
    $allowCoverModeration = $arr['intValue'];

    $arr = $config['allowFacebookAuthorization'];
    $allowFacebookAuthorization = $arr['intValue'];

    $arr = $config['allowMultiAccountsFunction'];
    $allowMultiAccountsFunction = $arr['intValue'];

    $page_id = "app";

    $error = false;
    $error_message = '';

    helper::newAuthenticityToken();

    $css_files = array("mytheme.css");
    $page_title = "App Settings";

    include_once("../html/common/admin_header.inc.php");
?>

    <body class="fix-header fix-sidebar card-no-border">

    <div id="main-wrapper">

        <?php

            include_once("../html/common/admin_topbar.inc.php");
        ?>

        <?php

            include_once("../html/common/admin_sidebar.inc.php");
        ?>

        <div class="page-wrapper">

            <div class="container-fluid">

                <div class="row page-titles">
                    <div class="col-md-5 col-8 align-self-center">
                        <h3 class="text-themecolor">Dashboard</h3>
                        <ol class="breadcrumb">
                            <li class="breadcrumb-item"><a href="/admin/main">Home</a></li>
                            <li class="breadcrumb-item active">App Settings</li>
                        </ol>
                    </div>
                </div>

                <?php

                    include_once("../html/common/admin_banner.inc.php");
                ?>

                <div class="row">
                    <div class="col-12">
                        <div class="card">
                            <div class="card-body">
                                <h4 class="card-title">App Settings</h4>
                                <h6 class="card-subtitle">Change application settings</h6>

                                <form action="/admin/app" method="post">

                                    <input type="hidden" name="authenticity_token" value="<?php echo helper::getAuthenticityToken(); ?>">

                                    <div class="form-group">

                                        <p>
                                            <input type="checkbox" name="allowPhotoModeration" id="allowPhotoModeration" <?php if ($allowPhotoModeration == 1) echo "checked=\"checked\"";  ?> />
                                            <label for="allowPhotoModeration">Mandatory pre-moderation for profile photo</label>
                                        </p>

                                        <p>
                                            <input type="checkbox" name="allowCoverModeration" id="allowCoverModeration" <?php if ($allowCoverModeration == 1) echo "checked=\"checked\"";  ?> />
                                            <label for="allowCoverModeration">Mandatory pre-moderation for profile cover</label>
                                        </p>

                                        <p style="display: none">
                                            <input type="checkbox" name="allowFacebookAuthorization" id="allowFacebookAuthorization" <?php if ($allowFacebookAuthorization == 1) echo "checked=\"checked\"";  ?> />
                                            <label for="allowFacebookAuthorization">Allow registration/authorization via Facebook</label>
                                        </p>

                                        <p>
                                            <input type="checkbox" name="allowMultiAccountsFunction" id="allowMultiAccountsFunction" <?php if ($allowMultiAccountsFunction == 1) echo "checked=\"checked\"";  ?> />
                                            <label for="allowMultiAccountsFunction">Enable creation of multi-accounts</label>
                                        </p>
                                    </div>

                                    <div class="form-group">
                                        <div class="col-xs-12">
                                            <button class="btn btn-info text-uppercase waves-effect waves-light" type="submit">Save</button>
                                        </div>
                                    </div>
                                </form>

                            </div>
                        </div>
                    </div>
                </div>



            </div> <!-- End Container fluid  -->

            <?php

                include_once("../html/common/admin_footer.inc.php");
            ?>

        </div> <!-- End Page wrapper  -->
    </div> <!-- End Wrapper -->

    </body>

    </html>